local _, slicore = ...;
slicore.Init = {};
local Init = slicore.Init;

local defaults = {
    sbcolor = {
        r = 0,
        g = 1,
        b = 1,
        hex = "00ffff"
    },
    printfarbe = {
        r = 0,
        g = 0.8,
        b = 0.4,
        hex = "00dd99"
    }
}

Init.commands = {
    ["help"] = function ()
        print(" ");
        Init:Print("Optionen:");
        Init:Print("  show    : Enables Slicer");
        Init:Print("  hide    : Disables Slicer");
        Init:Print("  options : Show Options Dialog (Try RMB on Slicer!)")
--	DEFAULT_CHAT_FRAME:AddMessage("    lock        : Locks Frame at current Position!");
--	DEFAULT_CHAT_FRAME:AddMessage("    unlock      : Unlocks Frame. Movementenabled!");
--	DEFAULT_CHAT_FRAME:AddMessage("    onlycombat  : Slicer appears only in combat");
--	DEFAULT_CHAT_FRAME:AddMessage("    onlyactive  : Slicer appears only if S&D active");
--	DEFAULT_CHAT_FRAME:AddMessage("    skills      : Slicer Skill frames toggle on/off");
--	DEFAULT_CHAT_FRAME:AddMessage("    riposte     : riposte frame toggle on/off");
--	DEFAULT_CHAT_FRAME:AddMessage("    menu        : Shows Options Menu!");
--	DEFAULT_CHAT_FRAME:AddMessage("    reset       : Reset Position!");
--	DEFAULT_CHAT_FRAME:AddMessage(" Resize: Hold down Mouse Button und use Wheel!");
    end,
--  Aufruf mit /sli bsp test
    -- ["bsp"] = {
    --     ["test"] = function(...)
    --         Init:Print("param:", tostringall(...));
    --     end
    -- },
    ["show"] = function()
        slicore.Mainwindow.RootFrame:Show();
    end,
    ["hide"] = function()
        slicore.Mainwindow.RootFrame:Hide();
    end,
    ["options"] = function()
        slicore.Optionswindow.RootFrame:SetShown(not slicore.Optionswindow.RootFrame:IsShown());
        slicore.Optionswindow.setoptions();
    end
};

function Init:GetPrintColor()
	local c = defaults.printfarbe;
	return c.r, c.g, c.b, c.hex;
end

function Init:Print(...)
    local hex = select(4, Init:GetPrintColor());
    local prefix = string.format("|cff%s%s|r", hex:upper(), "Slicer TNG:");	
    DEFAULT_CHAT_FRAME:AddMessage(string.join(" ", prefix, ...));
end

