local _, slicore = ...;
slicore.Mainwindow = {};
local Mainwindow = slicore.Mainwindow;
local MyMainWindow;
local InCombat = 0;
local lasttime = 0;
local Timesincelastupdate = 0;
local lastcombopoints = 0;
local Update_Rate = 0.1;
local SnDTime = 0;
local SATime = 0;
local KWTime = 0;
local AdreTime = 0;
local Adreexpire = 0;
local Kwexpire = 0;
local regOptionsclick = 0;

function Mainwindow:OnDragStart()
    if (SLICERTNG_OPTIONS["LockPosition"] == false) then
        MyMainWindow:StartMoving();
    end
end

function Mainwindow:OnDragStop()
    MyMainWindow:StopMovingOrSizing();
end

local function Dragger_OnDragStart(self)
    if (SLICERTNG_OPTIONS["UnlockBuffs"] == true) then
        if (self.frame:IsMovable()) then
            self.frame:StartMoving();
        end
    end
  end

local function Dragger_OnDragStop(self)
    if (SLICERTNG_OPTIONS["UnlockBuffs"] == true) then
        if (self.frame:IsMovable()) then
            self.frame:StopMovingOrSizing();
            MWXC,MWYC = MyMainWindow:GetCenter();
            TWXC,TWYC = self.frame:GetCenter();
            xdist = TWXC - MWXC
            ydist = TWYC - MWYC 
            self.frame:ClearAllPoints();
            self.frame:SetPoint("CENTER",slit_MainFrame,"CENTER",xdist,ydist);
            if (self.Name == "AD") then
                SLICERTNG_OPTIONS["BuffPositions"][1] = xdist;
                SLICERTNG_OPTIONS["BuffPositions"][2] = ydist;
            end
            if (self.Name == "KW") then
                SLICERTNG_OPTIONS["BuffPositions"][3] = xdist;
                SLICERTNG_OPTIONS["BuffPositions"][4] = ydist;
            end
            -- for key,value in next, self do
            --     print(key);
            --     print(value);
            -- end
        end
    end
end

function Mainwindow:MakeMovable(frame, dragger, movable, onDragStart, onDragStop)
    if (movable == nil) then
      movable = true;
    end

    dragger = dragger or frame;
    dragger.frame = frame;

    dragger:EnableMouse(movable);
    dragger:RegisterForDrag("LeftButton");
    frame:SetMovable(movable);
    frame:SetClampedToScreen(true);

    dragger.onDragStart = onDragStart;
    dragger.onDragStop = onDragStop;

    if (not dragger.hookedDragScripts) then
      dragger:HookScript("OnDragStart", Dragger_OnDragStart);
      dragger:HookScript("OnDragStop", Dragger_OnDragStop);
      dragger.hookedDragScripts = true;
    end
end

function Mainwindow:OnEvent(a,event,args,...)
-- print("event");
    --if (a) then
    --    print("a: " .. a)
    --end
    -- if (args) then
    --     print("args: " .. args)
    -- end
     --if (event) then
      --   print("event: " .. event);
     --end
    if(a == "PLAYER_REGEN_ENABLED") then
        InCombat = 1;
        if (SLICERTNG_OPTIONS["ShowAllways"] == false) then
            slicore.Mainwindow.RootFrame:Hide();
        end
    end
    if(a == "PLAYER_REGEN_DISABLED") then
        InCombat = 0;
        slicore.Mainwindow.RootFrame:Show();
    end
    if(a == "UNIT_AURA" and event == "player") then
        --print("event: " .. event .. " a: " .. a);
        Mainwindow:GetSnDTime();
    end
    if(a == "COMBAT_LOG_EVENT_UNFILTERED") then
        --platzhalter für CombatLog reactionen
    end
end

function Mainwindow:OnUpdateChecker(a,...)
    MyMainWindow.SLICER_ADRENALINE_ID = Mainwindow:GetSpellid(SLICER_ADRENALINE_SKILL);
    MyMainWindow.SLICER_BLADEFLURRY_ID = Mainwindow:GetSpellid(SLICER_BLADEFLURRY_SKILL);
    -- if (MyMainWindow.SLICER_ADRENALINE_ID == 1 or MyMainWindow.SLICER_BLADEFLURRY_ID == 0) then
    --     return;
    -- end
    MyMainWindow:SetScript("OnEvent", Mainwindow.OnEvent);
    MyMainWindow:SetScript("OnUpdate",Mainwindow.OnUpdate);
    MyMainWindow.HealthStatusBar:SetMinMaxValues(0,UnitHealthMax("player"));
end

function Mainwindow:OnUpdate(a,...)
    -- print("OnUpdate ");
    local akttime = GetTime();
    Timesincelastupdate = Timesincelastupdate + akttime - lasttime;
    lasttime = akttime;
    if (Timesincelastupdate > Update_Rate)  then
        Timesincelastupdate = 0;
        Mainwindow:GetSnDTime();
        MyMainWindow.SnDStatusBar:SetValue(SnDTime);
        if(SnDTime ~= 0) then
            MyMainWindow.SnDStatustxt:SetText(format("%.1f", SnDTime));
        else
            MyMainWindow.SnDStatustxt:SetText("off");
        end
        MyMainWindow.SAStatusBar:SetValue(SATime);
        if(SATime ~= 0) then
            MyMainWindow.SAStatustxt:SetText(format("%.1f", SATime));
        else
            MyMainWindow.SAStatustxt:SetText("off");
        end
        MyMainWindow.ErnergyStatusBar:SetValue(UnitPower("player",3));
        MyMainWindow.EnergyStatustxt:SetText(format("%.0f/100",UnitPower("player",3)));
        MyMainWindow.HealthStatusBar:SetMinMaxValues(0,UnitHealthMax("player"));
        MyMainWindow.HealthStatusBar:SetValue(UnitHealth("player"));
        MyMainWindow.HealthStatustxt:SetText(format("%.0f",UnitHealth("player")));
        comboPoints = GetComboPoints("player", "target");
        if (lastcombopoints ~= comboPoints) then
            --print("Change found");
            lastcombopoints = comboPoints;
            Mainwindow:Show_Combopoints(lastcombopoints);
        end
        Mainwindow:Checkcooldowns();
        -- print(UnitPower("player",3)); --3 = Energy!
        -- print(UnitPowerType("player"));
        -- print(UnitHealth("player"));
        if (regOptionsclick == 0) then
            Mainwindow:Anzeige();
            MyMainWindow:SetScript("OnMouseDown",function(self, button)
                if (button) then
                    print("button: " .. button)
                end
                if (button == "RightButton") then
                    slicore.Optionswindow.RootFrame:SetShown(not slicore.Optionswindow.RootFrame:IsShown());
                    slicore.Optionswindow.setoptions();
                end
            end)
            regOptionsclick = 1;
        end
    end
end

function Mainwindow:startup (launchlevel)
    if (launchlevel == 1) then
        Mainwindow.RootFrame = CreateFrame("Frame", "slit_MainFrame", UIParent, BackdropTemplateMixin and 'BackdropTemplate');
        MyMainWindow = Mainwindow.RootFrame;
        MyMainWindow:SetSize(165,84);
        MyMainWindow:SetPoint("CENTER",UiParent,"CENTER");
        MyMainWindow:SetClampedToScreen(true);
        MyMainWindow:SetBackdrop({bgFile = "Interface\\TutorialFrame\\TutorialFrameBackground",
            edgeFile = nil; --"Interface\\DialogFrame\\UI-DialogBox-Border",
            tile = true,
            tileSize = 32,
            edgeSize = 10,
            insets = {left = 5, right = 5, top = 5, bottom = 5}
        });
        MyMainWindow:RegisterEvent("UNIT_AURA");
        MyMainWindow:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
        MyMainWindow:RegisterEvent("PLAYER_REGEN_ENABLED");
        MyMainWindow:RegisterEvent("PLAYER_REGEN_DISABLED");
        --MyMainWindow:SetScript("OnEvent", Mainwindow.OnEvent);
        --MyMainWindow:SetScript("OnUpdate",Mainwindow.OnUpdate);
        MyMainWindow:SetScript("OnUpdate",Mainwindow.OnUpdateChecker);
        MyMainWindow:EnableMouse(true);
        MyMainWindow:SetMovable(true);
        MyMainWindow:RegisterForDrag("LeftButton");
        MyMainWindow:SetScript("OnDragStart",Mainwindow.OnDragStart);
        MyMainWindow:SetScript("OnDragStop",Mainwindow.OnDragStop);

        slicore.Mainwindow.SnDStatusBar = CreateFrame("StatusBar", "STNG_SnDStatusBar", slit_MainFrame);
        MyMainWindow.SnDStatusBar = slicore.Mainwindow.SnDStatusBar; 
        
        MyMainWindow.SnDStatusBar:SetSize(149,14);
        MyMainWindow.SnDStatusBar:SetPoint("TOP",slit_MainFrame,"TOP",0,-8);
        MyMainWindow.SnDStatusBar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar");
        MyMainWindow.SnDStatusBar:SetMinMaxValues(0,100);
        MyMainWindow.SnDStatusBar:SetValue(50);
        MyMainWindow.SnDStatusBar:SetStatusBarColor(0,1,1);
        MyMainWindow.SnDStatusBar:SetFrameLevel(MyMainWindow.SnDStatusBar:GetFrameLevel()-1);
        MyMainWindow.SnDStatustxt = MyMainWindow:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall");
        MyMainWindow.SnDStatustxt:SetPoint("TOP","STNG_SnDStatusBar","TOP",0,0);
        MyMainWindow.SnDStatustxt:SetTextHeight(MyMainWindow.SnDStatusBar:GetHeight() - 2);
        MyMainWindow.SnDStatustxt:SetWidth(MyMainWindow.SnDStatusBar:GetWidth()-2);
        MyMainWindow.SnDStatustxt:SetJustifyH("RIGHT");

        slicore.Mainwindow.SAStatusBar = CreateFrame("StatusBar", "STNG_SAStatusBar", slit_MainFrame);
        MyMainWindow.SAStatusBar = slicore.Mainwindow.SAStatusBar; 
        
        MyMainWindow.SAStatusBar:SetSize(149,14);
        MyMainWindow.SAStatusBar:SetPoint("TOP",slit_MainFrame,"TOP",0,-52);
        MyMainWindow.SAStatusBar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar");
        MyMainWindow.SAStatusBar:SetMinMaxValues(0,100);
        MyMainWindow.SAStatusBar:SetValue(50);
        MyMainWindow.SAStatusBar:SetStatusBarColor(0.3,0.3,1);
        MyMainWindow.SAStatusBar:SetFrameLevel(MyMainWindow.SAStatusBar:GetFrameLevel()-1);
        MyMainWindow.SAStatustxt = MyMainWindow:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall");
        MyMainWindow.SAStatustxt:SetPoint("TOP","STNG_SAStatusBar","TOP",0,0);
        MyMainWindow.SAStatustxt:SetTextHeight(MyMainWindow.SAStatusBar:GetHeight() - 2);
        MyMainWindow.SAStatustxt:SetWidth(MyMainWindow.SAStatusBar:GetWidth()-2);
        MyMainWindow.SAStatustxt:SetJustifyH("RIGHT");


        MyMainWindow.Combobars = {};
        Mainwindow:CreateComboBar(1);
        Mainwindow:CreateComboBar(2);
        Mainwindow:CreateComboBar(3);
        Mainwindow:CreateComboBar(4);
        Mainwindow:CreateComboBar(5);
        Mainwindow:Show_Combopoints(2);

        MyMainWindow.ErnergyStatusBar = CreateFrame("StatusBar", "STNG_EnergyStatusBar", slit_MainFrame);
        MyMainWindow.ErnergyStatusBar:SetSize(149,14);
        MyMainWindow.ErnergyStatusBar:SetPoint("TOP",slit_MainFrame,"TOP",0,-30);
        MyMainWindow.ErnergyStatusBar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar");
        MyMainWindow.ErnergyStatusBar:SetMinMaxValues(0,100);
        MyMainWindow.ErnergyStatusBar:SetValue(50);
        MyMainWindow.ErnergyStatusBar:SetStatusBarColor(1,1,0);
        MyMainWindow.ErnergyStatusBar:SetFrameLevel(MyMainWindow.ErnergyStatusBar:GetFrameLevel()-1);
        MyMainWindow.EnergyStatustxt = MyMainWindow.ErnergyStatusBar:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall");
        MyMainWindow.EnergyStatustxt:SetPoint("TOP","STNG_EnergyStatusBar","TOP",0,0);
        MyMainWindow.EnergyStatustxt:SetTextHeight(MyMainWindow.ErnergyStatusBar:GetHeight() - 2);
        MyMainWindow.EnergyStatustxt:SetWidth(MyMainWindow.ErnergyStatusBar:GetWidth()-2);
        MyMainWindow.EnergyStatustxt:SetJustifyH("RIGHT");

        MyMainWindow.HealthStatusBar = CreateFrame("StatusBar", "STNG_HealthStatusBar", slit_MainFrame);
        MyMainWindow.HealthStatusBar:SetSize(149,14);
        MyMainWindow.HealthStatusBar:SetPoint("TOP",slit_MainFrame,"TOP",0,-46);
        MyMainWindow.HealthStatusBar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar");
        MyMainWindow.HealthStatusBar:SetMinMaxValues(0,UnitHealthMax("player"));
        MyMainWindow.HealthStatusBar:SetValue(50);
        MyMainWindow.HealthStatusBar:SetStatusBarColor(0,1,0);
        MyMainWindow.HealthStatusBar:SetFrameLevel(MyMainWindow.HealthStatusBar:GetFrameLevel()-1);
        MyMainWindow.HealthStatustxt = MyMainWindow.HealthStatusBar:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall");
        MyMainWindow.HealthStatustxt:SetPoint("TOP","STNG_HealthStatusBar","TOP",0,0);
        MyMainWindow.HealthStatustxt:SetTextHeight(MyMainWindow.HealthStatusBar:GetHeight() - 2);
        MyMainWindow.HealthStatustxt:SetWidth(MyMainWindow.HealthStatusBar:GetWidth()-2);
        MyMainWindow.HealthStatustxt:SetJustifyH("RIGHT");
    end

    if (launchlevel == 2) then -- jetzt sind auch die Spells geladen!
        MyMainWindow.SLICER_ADRENALINE_ID = Mainwindow:GetSpellid(SLICER_ADRENALINE_SKILL);
        if (MyMainWindow.SLICER_ADRENALINE_ID ~= nil) then
            MyMainWindow.AdrenalinButton = CreateFrame("Button", "STNG_AdrenalinBut", slit_MainFrame, BackdropTemplateMixin and 'BackdropTemplate');
            MyMainWindow.AdrenalinButton:SetSize(30,30);
            MyMainWindow.AdrenalinButton:SetPoint("CENTER",slit_MainFrame,"CENTER",SLICERTNG_OPTIONS["BuffPositions"][1],SLICERTNG_OPTIONS["BuffPositions"][2]);
            --MyMainWindow.AdrenalinButton:SetClampedToScreen(true);
            MyMainWindow.AdrenalinButton:SetBackdrop({
                bgFile = "Interface\\Icons\\Spell_Shadow_ShadowWordDominate",
                edgeFile = nil, 
                tile = false,
                tileSize = 32,
                edgeSize = 10,
                insets = {left = 0, right = 0, top = 0, bottom = 0}
            });
            -- MyMainWindow.AdrenalinButton:SetMovable(false);
            -- MyMainWindow.AdrenalinButton:RegisterForDrag("LeftButton");
            -- MyMainWindow.AdrenalinButton:SetScript("OnDragStart",Mainwindow.OnDragStartbuffs);
            -- MyMainWindow.AdrenalinButton:SetScript("OnDragStop",Mainwindow.OnDragStopbuffs);
            MyMainWindow.AdrenalinButton.Name = "AD";
            Mainwindow:MakeMovable(MyMainWindow.AdrenalinButton);
            MyMainWindow.SLICER_ADRENALINE_COOL = 1;

            MyMainWindow.AdrenalinButtoncd = CreateFrame("Frame",nil,STNG_AdrenalinBut);
            MyMainWindow.AdrenalinButtoncd:SetSize(MyMainWindow.AdrenalinButton:GetWidth(),MyMainWindow.AdrenalinButton:GetHeight());
            MyMainWindow.AdrenalinButtoncd:SetPoint("CENTER");
            MyMainWindow.myTexture = MyMainWindow.AdrenalinButtoncd:CreateTexture()
            MyMainWindow.myTexture:SetAllPoints()
            MyMainWindow.myTexture:SetTexture("Interface\\Icons\\Spell_Shadow_ShadowWordDominate")
            MyMainWindow.myCooldown = CreateFrame("Cooldown", "myCooldown", MyMainWindow.AdrenalinButtoncd, "CooldownFrameTemplate")
            MyMainWindow.myCooldown:SetAllPoints()
            MyMainWindow.myCooldown:SetReverse(true);
            MyMainWindow.AdrenalinButton:SetBackdropColor(0.5,0.5,0.5,0.5);
            MyMainWindow.myCooldown:SetSwipeColor(1, 1, 1, 1);
        end

        MyMainWindow.SLICER_BLADEFLURRY_ID = Mainwindow:GetSpellid(SLICER_BLADEFLURRY_SKILL);
        if (MyMainWindow.SLICER_BLADEFLURRY_ID ~= nil) then
            MyMainWindow.KlingenwiButton = CreateFrame("Button", "STNG_KlingenwiBut", slit_MainFrame, BackdropTemplateMixin and 'BackdropTemplate');
            MyMainWindow.KlingenwiButton:SetSize(30,30);
            MyMainWindow.KlingenwiButton:SetPoint("CENTER",slit_MainFrame,"CENTER",SLICERTNG_OPTIONS["BuffPositions"][3],SLICERTNG_OPTIONS["BuffPositions"][4]);
            --MyMainWindow.KlingenwiButton:SetClampedToScreen(true);
            MyMainWindow.KlingenwiButton:SetBackdrop({
                bgFile = "Interface\\Icons\\Ability_Warrior_PunishingBlow",
                edgeFile = nil; 
                tile = false,
                tileSize = 32,
                edgeSize = 10,
                insets = {left = 0, right = 0, top = 0, bottom = 0}
            });
            MyMainWindow.KlingenwiButton.Name = "KW";
            Mainwindow:MakeMovable(MyMainWindow.KlingenwiButton);
            MyMainWindow.SLICER_BLADEFLURRY_COOL = 1;
            
            MyMainWindow.KlingenwiButtoncd = CreateFrame("Frame",nil,STNG_KlingenwiBut);
            MyMainWindow.KlingenwiButtoncd:SetSize(MyMainWindow.KlingenwiButton:GetWidth(),MyMainWindow.KlingenwiButton:GetHeight());
            MyMainWindow.KlingenwiButtoncd:SetPoint("CENTER")
            MyMainWindow.myTexturekw = MyMainWindow.KlingenwiButtoncd:CreateTexture()
            MyMainWindow.myTexturekw:SetAllPoints()
            MyMainWindow.myTexturekw:SetTexture("Interface\\Icons\\Ability_Warrior_PunishingBlow")
            MyMainWindow.myCooldownkw = CreateFrame("Cooldown", "myCooldownkw", MyMainWindow.KlingenwiButtoncd, "CooldownFrameTemplate")
            MyMainWindow.myCooldownkw:SetAllPoints()
            MyMainWindow.myCooldownkw:SetReverse(true);
            MyMainWindow.KlingenwiButton:SetBackdropColor(0.5,0.5,0.5,0.5);
            MyMainWindow.myCooldownkw:SetSwipeColor(1, 1, 1, 1);
        end

        -- for key,value in next, slicore.Optionswindow.RootFrame.resetbuffs do
        --     print(key);
        --     print(value);
        -- end
        slicore.Optionswindow.RootFrame.resetbuffs:SetScript("OnClick", function ()
            MyMainWindow.AdrenalinButton:SetPoint("CENTER",slit_MainFrame,"CENTER",93,15);
            slicore.Mainwindow.RootFrame.KlingenwiButton:SetPoint("CENTER",slit_MainFrame,"CENTER",93,-15);
            SLICERTNG_OPTIONS["BuffPositions"] = {93,15,93,-15};
        end)
    end
end

function Mainwindow:CreateComboBar(lfdnr)
    MyMainWindow.Combobars[lfdnr] = CreateFrame("Frame", "STNG_ComboBar"..lfdnr, slit_MainFrame);
    MyMainWindow.Combobars[lfdnr]:SetSize(28,5);
    MyMainWindow.Combobars[lfdnr]:SetPoint("TOP",slit_MainFrame,"TOP",-60 + ((lfdnr-1)*30),-24);
    MyMainWindow.Combobars[lfdnr].texture = MyMainWindow.Combobars[lfdnr]:CreateTexture(nil, 'ARTWORK');
    MyMainWindow.Combobars[lfdnr].texture:SetAllPoints(MyMainWindow.Combobars[lfdnr]);
    MyMainWindow.Combobars[lfdnr].texture:SetColorTexture(1,1,0,1);
end

function Mainwindow:GetSnDTime(a)
    local found = 0;
    local adrefound = 0;
    local kwfound = 0;
    local SAfound = 0;
    for i=1,40 do
        name, rank, icon, count, dispelType, expires, caster, what, isStealable, spellID = UnitDebuff("target", i) 
        if (name == SLICER_SA_SKILL) then
            local oldSAtime = SATime;
            SATime = expires - GetTime();
            SAfound = 1;
            if (SATime > oldSAtime) then
                MyMainWindow.SAStatusBar:SetMinMaxValues(0,SATime);
            end
        end
    end
    for i=1,40 do
        name, rank, icon, count, dispelType, expires, caster, what, isStealable, spellID = UnitBuff("player",i);     
        if (name == SLICER_SnD_SKILL) then
            local oldtime = SnDTime;
            SnDTime = expires - GetTime();
            found = 1;
            if (SnDTime > oldtime) then
                MyMainWindow.SnDStatusBar:SetMinMaxValues(0,SnDTime);
            end
        end
        if (name == SLICER_ADRENALINE_SKILL) then
            local oldadrtime = AdreTime;
            AdreTime = expires - GetTime();
            adrefound = 1;
            if (AdreTime > oldadrtime) then
                MyMainWindow.myCooldown:SetCooldown(GetTime(), AdreTime);
                Adreexpire = expires;
            end
        end
        if (name == SLICER_BLADEFLURRY_SKILL) then
            local oldkwtime = KWTime;
            KWTime = expires - GetTime();
            kwfound = 1;
            if (KWTime > oldkwtime) then
                MyMainWindow.myCooldownkw:SetCooldown(GetTime(), KWTime);
                Kwexpire = expires;
            end
        end
    end
    if (found == 0) then 
        SnDTime = 0; 
    end
    if (SAfound == 0) then
        SATime = 0;
    end
    if(adrefound == 0) then 
        AdreTime = 0;
        Adreexpire = GetTime() -1;
    end
    if(kwfound == 0) then
        KWTime = 0;
        Kwexpire = GetTime() -1;
    end
end

function Mainwindow:Show_Combopoints(amount)
    if (amount == nil) then
        amount = 0;
    end
    for i=1,5 do
        if (i <= amount) then
            MyMainWindow.Combobars[i]:Show();    
            MyMainWindow.Combobars[i].texture:SetColorTexture(0.2*amount,0.2*amount,0,1); -- dynamische farbe
        else
            MyMainWindow.Combobars[i]:Hide();
        end
    end
end

function Mainwindow:GetSpellid(spellname)
    local i,done,name;
    local rank,id,hrank;
	i = 1;
	while not done do
		name,rank = GetSpellBookItemName(i,BOOKTYPE_SPELL);
		if not name then
			done = true;
		elseif (name == spellname) then
			return i;
		end
		i = i + 1;
    end
    return 0;
end

function Mainwindow:Checkcooldowns()
    if (MyMainWindow.SLICER_ADRENALINE_ID == nil) then
        print("ID == NIL!");
        return
    end
    if (MyMainWindow.SLICER_ADRENALINE_ID ~= 0) then
		local start, duration, enabled = GetSpellCooldown(MyMainWindow.SLICER_ADRENALINE_ID, BOOKTYPE_SPELL);
        --print (strjoin(" - ", "Adr: ",tostring(start), tostring(duration), tostring(enabled),tostring(Adreexpire), tostring(GetTime())));
		if (duration ~= 0 and GetTime() > Adreexpire)  then
			if ((MyMainWindow.SLICER_ADRENALINE_COOL == 1) and (duration > 1)) then
                MyMainWindow.SLICER_ADRENALINE_COOL = 0;
                MyMainWindow.AdrenalinButton:Hide();
			end
		else
            MyMainWindow.SLICER_ADRENALINE_COOL = 1;
            MyMainWindow.AdrenalinButton:Show();
		end
	else
        MyMainWindow.SLICER_ADRENALINE_COOL = 0;
        if(MyMainWindow.AdrenalinButton ~= nil) then
            MyMainWindow.AdrenalinButton:Hide();
        end
    end
    if (MyMainWindow.SLICER_BLADEFLURRY_ID ~= 0) then
		local start, duration,enabled = GetSpellCooldown(MyMainWindow.SLICER_BLADEFLURRY_ID,BOOKTYPE_SPELL);
        --print (strjoin(" - ", "KW",tostring(MyMainWindow.SLICER_BLADEFLURRY_ID),tostring(start), tostring(duration), tostring(enabled),tostring(Kwexpire), tostring(GetTime())));
		if (duration ~= 0 and GetTime() > Kwexpire)  then
            --print("duration ~= 0 and GetTime() > Kwexpire");
			if ((MyMainWindow.SLICER_BLADEFLURRY_COOL == 1) and (duration > 1)) then
                --print("(MyMainWindow.SLICER_BLADEFLURRY_COOL == 1) and (duration > 1)");
                MyMainWindow.SLICER_BLADEFLURRY_COOL = 0;
                MyMainWindow.KlingenwiButton:Hide();
			end
		else
            MyMainWindow.SLICER_BLADEFLURRY_COOL = 1;
            MyMainWindow.KlingenwiButton:Show();
		end
	else
        MyMainWindow.SLICER_BLADEFLURRY_COOL = 0;
        if (MyMainWindow.KlingenwiButton ~= nil) then
            MyMainWindow.KlingenwiButton:Hide();
        end
    end
    
end

function Mainwindow:Anzeige()
    local MWysize = 38; 
    local MWypos = -31; -- SND.height = -14 + border = -16 + Combos = -21 + border = -23 + base = -8 = -31
    if (slicore.VariablesLoaded) then
        MyMainWindow.HealthStatusBar:SetShown(SLICERTNG_OPTIONS["ShowLife"]);
        MyMainWindow.ErnergyStatusBar:SetShown(SLICERTNG_OPTIONS["ShowEnergy"]);
        MyMainWindow.SAStatusBar:SetShown(SLICERTNG_OPTIONS["ShowSunder"]);
        MyMainWindow.SAStatustxt:SetShown(SLICERTNG_OPTIONS["ShowSunder"]);
    end
    if (SLICERTNG_OPTIONS["ShowLife"] == true) then 
        MWysize = MWysize + 16; 
        MyMainWindow.HealthStatusBar:SetPoint("TOP",slit_MainFrame,"TOP",0,MWypos);
        MWypos = MWypos - 16;
    end
    if (SLICERTNG_OPTIONS["ShowEnergy"] == true) then
        MWysize = MWysize + 16; 
        MyMainWindow.ErnergyStatusBar:SetPoint("TOP",slit_MainFrame,"TOP",0,MWypos);
        MWypos = MWypos - 16;
    end
    if (SLICERTNG_OPTIONS["ShowSunder"] == true) then
        MWysize = MWysize + 16; 
        MyMainWindow.SAStatusBar:SetPoint("TOP",slit_MainFrame,"TOP",0,MWypos);
        MWypos = MWypos - 16;
    end
    MyMainWindow:SetSize(165,MWysize);
end